// Zum kompelieren "gcc testMain.c functions.c functions.h -lcunit"

#include "CUnit/Basic.h"
#include "functions.h"


//Init Funktion, wird vor den Tests der Suite ausgefuehrt
int init_sumValuesSuite(void) {
	return 0;
}

//Clean Funktion, wird nach den Tests ausgefuehrt
int clean_sumValuesSuite(void) {
	return 0;
}

void test_sumValues(void) {
	CU_ASSERT_TRUE(sumValues(4,3) == 7);
	CU_ASSERT_FALSE(sumValues(4,3) == 8);
}
//----------------------------------------
int init_returnCharSuite(void) {
	return 0;
}

int clean_returnCharSuite(void) {
	return 0;
}

void test_returnChar(void) {
	CU_ASSERT_STRING_EQUAL(returnChar("Test"),"Test");
	CU_ASSERT_STRING_NOT_EQUAL(returnChar("Test"),"stimmt nicht");
	CU_ASSERT_EQUAL(returnChar("Test"),"Test");
}
//----------------------------------------

int init_exampleTestSuite(void) {
	return 0;
}

int clean_exampleTestSuite(void) {
	return 0;
}

void test_exampleTest1(void) {
	int x = 5;

	if(x==5) {
		CU_PASS("Test erfolgreich");
	} else {
		CU_FAIL("Test fehlgeschlagen");
	}
}

void test_exampleTest2(void) {
	int x = 5;

	CU_ASSERT(x==5);
	CU_ASSERT(x!=5); //schlaegt fehl
}

//----------------------------------------

int main() {
	CU_pSuite suite;

	CU_initialize_registry(); //CUnit initialisieren

	suite = CU_add_suite("sumValues Tests",init_sumValuesSuite,clean_sumValuesSuite); //Suite erstellen
	
	CU_add_test(suite,"Sum Values", test_sumValues); //Tests hinzufuegen
	
	suite = CU_add_suite("returnChar Tests",init_returnCharSuite,clean_returnCharSuite); // Suite erstellen

	CU_add_test(suite,"Return Char", test_returnChar); //Tests hinzufuegen
	
	suite = CU_add_suite("exampleTest Tests",init_exampleTestSuite,clean_exampleTestSuite); // Suite erstellen

	CU_add_test(suite,"Example Test 1", test_exampleTest1);
	CU_add_test(suite,"Example Test 2", test_exampleTest2);


	CU_basic_run_tests(); //Tests ausfuehren
	CU_cleanup_registry();

	return 0;
}
